//------------------------------------------------------------------------------
//	Opg̃t[GWvZƃt[G
//------------------------------------------------------------------------------

#include "FourierCalc.hpp"
#include <cmath>

// Opgi֐j̃t[GWvZ
void TriangularFourieCoefs(int kDash, float ak[])
{
	const float FACTOR = 8.0/(3.14159265*3.14159265);	// 8/(*)
	for (int n=0; n<kDash; n++)
	{
		int k = 2*n + 1;
		ak[n] = FACTOR/(k*k);
	}
}

// t[G cos ̌vZɈlȈʑ̌ʂ
float SynthesisPhase(float t, int kDash, float ak[], float phi)
{
	float ft = 0.0;
	for (int k=1; k<=kDash; k++)
		ft = ft + ak[k-1]*cos((2*k-1)*t + phi);
	return ft;
}

