//------------------------------------------------------------------------------
//	Opg̃t[Gň̈ʑ^
//
//	́F	PB0Fʑω邽߂̒lǂݎ邽߂ AD ϊ̓
//	óF	PA4Ft[Gŋ߂Opg
//			PA5F̈ʑ^ăt[Gg`
//
//		쐬ҁFO㒼C2013/10/23 쐬C(c)O㒼 2013
//------------------------------------------------------------------------------

#include "stm32f4_discovery.h"
#include "Peripheral.hpp"
#include "FourierCalc.hpp"	// t[GW̌vZƃt[G
#include "AdcPolling.hpp"	// AD ϊp

__IO bool ok_;				// __IO  volatile ̃GCAX

const float A0_ = 1024.0f;	// o͔g`̐U
const int16_t DC_ = 2048;	// DAC  0 ɑl

// float ^̃f[^ DA ϊɗ^悤ɕϊ
inline uint16_t ToDac(float x) { return (int16_t)(A0_*x) + DC_; }

int main()
{
	const int FS = 8000;				// W{g
	const float PI = 3.1415926535f;	// 
	const float PI2 = 2.0f*PI;			// 2
	const float D_TH = PI2*261.6/FS;	// {gi261.6 HzjɑΉl
	const int K_DASH = 10;              // (K+1)/2

	float ak[K_DASH];		// Opg̃t[GW

	InitializePeripheral(FS);

	// ADC1, ch8, PB0 gp邽߂̏
	AdcPolling adc(ADC1, ADC_Channel_8, GPIOB, GPIO_Pin_0);

	// Opg̃t[GWvZ
	TriangularFourieCoefs(K_DASH, ak);

	float t = 0.0;
	adc.SoftwareStart();	// ŏ AD ϊ̎w
	ok_ = false;

	while (true)
	{
		if (ok_)
		{
			// t[GOpg
			uint16_t x1 = ToDac(SynthesisPhase(t, K_DASH, ak));

			// AD ϊɗ^dňʑς邽߂̏
			uint16_t adcValue = adc.WaitGetAndStart();
			float phase = (PI/DC_)*(adcValue - DC_);

			// ʑωg`
			uint16_t x2 = ToDac(SynthesisPhase(t, K_DASH, ak, phase));

			// DAC ̗`l̃obt@փf[^]
			DAC_SetDualChannelData(DAC_Align_12b_R, x2, x1);
			// `lɃgK
			DAC_DualSoftwareTriggerCmd(ENABLE);

			t = t + D_TH;
			if (t > PI2) t = t - PI2;

			// LED ̓_/̏Ԃ AD ϊꂽlɑΉ
			if (adcValue < 0xf80) adcValue = adcValue + 0x80;
			SW_Monitor(adcValue >> 8);

			ok_ = false;
		}
	}
}
