//------------------------------------------------------------------------------
//	t[GWVv\̌ɂ鐔lϕŋ߂
//
//		쐬ҁFO㒼C2013/05/06 쐬C(c)O㒼 2013
//------------------------------------------------------------------------------

#include "stm32f4_discovery.h"
#include <cassert>
#include <cmath>
#include "FourierCoefs.hpp"

// Vv\̌gėUԃf[^t[GW߂֐
//		͌vZȂ
void FourierCoefs(const int16_t xn[], int nData, float an[], float bn[],
				  int order)
{
	float* fn = new float[nData];	// Ɨ̈
	float period = nData - 1;

	for (int k=0; k<order; k++)
	{
		float kPi2_T = 6.283185f*(k + 1)/period;

		for (int n=0; n<nData; n++)
			fn[n] = xn[n]*cosf(n*kPi2_T);
		an[k] = 2.0f*Simpson(fn, nData)/period;

		for (int n=0; n<nData; n++)
			fn[n] = xn[n]*sinf(n*kPi2_T);
		bn[k] = 2.0f*Simpson(fn, nData)/period;
	}

	delete[] fn;
}


// Vv\̌ɂ鐔lϕ (ϕ֐̗Ul^Ăꍇ)
//		h = 1 Ɖ肵Ă
float Simpson(const float fn[], int n)
{
	assert((n %2) != 0);	// f[^ł邱ƂmF
	
	float y1 = 0;
	for (int k=2; k<n-1; k+=2) y1 = y1 + fn[k];

	float y2 = 0;
	for (int k=1; k<n; k+=2) y2 = y2 + fn[k];

	return (fn[0] + fn[n-1] + 2.0f*y1 + 4.0f*y2)/3.0f;
}
