//------------------------------------------------------------------------------
//	AD ϊ|[OŎgp邽߂̃NX̒`
//		쐬ҁFO㒼C2013/10/23 쐬C(c)O㒼 2013
//------------------------------------------------------------------------------

#include "stm32f4xx_adc.h"

#ifndef ADC_POLLING_HPP
#define ADC_POLLING_HPP

class AdcPolling
{
private:
	ADC_TypeDef* adcX_;		// ADC1, 2, 3 ̋

	static bool first_;	// P񂾂s邽

	// Rs[RXgN^̎gp֎~
	AdcPolling(const AdcPolling& adc);
	// Zq̎gp֎~
	AdcPolling& operator=(const AdcPolling& adc);

public:
	// sRXgN^
	AdcPolling(ADC_TypeDef* adcN, uint8_t channel, GPIO_TypeDef* gpioX,
			   uint32_t gpioPin);

	// AD ϊJn
	inline void SoftwareStart() { ADC_SoftwareStartConv(adcX_); }

	// AD ϊI܂ő҂
	inline void WaitOfConversion()
	{ while ( ADC_GetFlagStatus(adcX_, ADC_FLAG_EOC) == RESET); }

	// AD ϊꂽl擾
	inline uint16_t Get() { return ADC_GetConversionValue(adcX_); }

	// AD ϊ̏ImFCl擾
	inline uint16_t WaitAndGet()
	{
		WaitOfConversion();
		return Get();
	}

	// AD ϊ̏ImFɒl擾C AD ϊJn
	inline uint16_t GetAndStart()
	{
		uint16_t val = Get();
		SoftwareStart();		// \tgEFAɂϊ̊Jn
		return val;
	}

	// AD ϊ̏ImFCl擾C AD ϊJn
	inline uint16_t WaitGetAndStart()
	{
		uint16_t val = WaitAndGet();
		SoftwareStart();		// \tgEFAɂϊ̊Jn
		return val;
	}
};

#endif	// ADC_POLLING_HPP
