//------------------------------------------------------------------------------
//	t[G
//		ʑ𖳎Ȃŕꉹ֐ƁCĕꉹ֐
//------------------------------------------------------------------------------

#include "SynthesisTwoMethods.hpp"
#include <cmath>

// ͎g킸ɍ
void SynthesisWithoutDC(const float an[], const float bn[], int16_t vn[],
						int maxOrder, int nT0)
{
	float pi2_T =2.0*3.1415926536/(float)nT0;	// 2/T0

	for (int n=0; n<nT0; n++) vn[n] = 0;
	for (int k=0; k<maxOrder; k++)		// maxOrder ܂ł̘a
	{
		float kPi2T = (k + 1)*pi2_T;
		for (int n=0; n<nT0; n++)
			vn[n] += an[k]*cos(kPi2T*n) + bn[k]*sin(kPi2T*n);
	}
}

// ʑ𖳎č
void SynthesisSin(const float cn[], int16_t vn[],int maxOrder, int nT0)
{
	float pi2_T =2.0*3.1415926536/(float)nT0;	// 2/T0

	for (int n=0; n<nT0; n++) vn[n] = 0;
	for (int k=0; k<maxOrder; k++)		// maxOrder ܂ł̘a
	{
		float kPi2T = (k + 1)*pi2_T;
		for (int n=0; n<nT0; n++) vn[n] += cn[k]*sin(kPi2T*n);
	}
}
