//------------------------------------------------------------------------------
//	vZt[GWgăt[Gɂꉹ̔
//		ꉹ̎ނXCb`Ő؂ւ
//		USER BUTTONiFjƈԉ
//
//	óF	PA4Fʏ̃t[Gɂg`
//			PA5Fʑ𖳎ăt[Gg`
//
//		쐬ҁFO㒼C2013/05/25 쐬C(c)O㒼 2013
//------------------------------------------------------------------------------

#include "stm32f4_discovery.h"
#include <cmath>
#include "Peripheral.hpp"
#include "SynthesisTwoMethods.hpp"
#include "vowels.hpp"
#include "FourierCoefs.hpp"
#include "WaitingWarning.hpp"

// t[GW
const int HARMO_MAX_ = 20;
const int N_T0_ = N_DATA_ - 1;		// 1 ɑΉ_

float an_[N_VOWEL_][HARMO_MAX_];	// t[G cos W
float bn_[N_VOWEL_][HARMO_MAX_];	// t[G sin W
float cn_[N_VOWEL_][HARMO_MAX_];	// ʑ낦ꍇ̃t[GW
int16_t vn_ab[N_T0_];	// o͂鍇ꉹ̃f[^iʏ̃t[Gj
int16_t vn_c[N_T0_];	// o͂鍇ꉹ̃f[^iʑ낦t[Gj

__IO bool ok_;

inline float Magnitude(float x1, float x2)
{	return sqrt(x1*x1 + x2*x2); }

int main()
{
	const int FS	 = 8000.0f; 	// W{g
	const int16_t DC = 2048;		// DAC  0 ɑl
	const int COUNT = 4000; 	// ̒߂萔

	InitializePeripheral(FS);
	STM_EVAL_PBInit(BUTTON_USER, BUTTON_MODE_GPIO);

	// t[GW̌vZ
	for (int k=0; k<N_VOWEL_; k++)
		FourierCoefs(&snOrg_[k][0], N_DATA_, &an_[k][0], &bn_[k][0], HARMO_MAX_);

	// ʏ̃t[GWʑ낦t[GWɕϊ
	for (int k=0; k<N_VOWEL_; k++)
		for (int m=0; m<HARMO_MAX_; m++)
			cn_[k][m] = Magnitude(an_[k][m], bn_[k][m]);

	ok_ = false;
	int ptr = 0;
	int counter = 0;
	int16_t sw;

	while (true)
	{
		if (ok_)
		{
			if ((counter == 0) && (STM_EVAL_PBGetState(BUTTON_USER) == 1))
			{
				Waiting(sw, 1, 5);
				SW_Monitor(sw); 		// XCb`̏Ԃ LED ŕ\
				// ʏ̃t[G
				SynthesisWithoutDC(&an_[sw-1][0], &bn_[sw-1][0], vn_ab,
								   HARMO_MAX_, N_T0_);
				// ʑ낦t[G
				SynthesisSin(&cn_[sw-1][0], vn_c, HARMO_MAX_, N_T0_);

				counter = COUNT;
			}

			if (counter > 0)
			{
				uint16_t x1 = vn_ab[ptr] + DC;		// ʏ̃t[G
				uint16_t x2 = vn_c[ptr] + DC;		// ʑ낦ăt[G
				if (++ptr >= N_T0_) ptr = 0;

				// DAC ̗`l̃obt@փf[^]
				DAC_SetDualChannelData(DAC_Align_12b_R, x2, x1);
				// `lɃgK
				DAC_DualSoftwareTriggerCmd(ENABLE);

				counter--;
			}
			ok_ = false;
		}
	}
}
